/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.inbox.xml;

import org.apache.avalon.framework.service.ServiceException;
import org.apache.avalon.framework.service.ServiceManager;
import org.apache.avalon.framework.service.Serviceable;
import org.apache.lenya.ac.User;
import org.apache.lenya.inbox.AbstractInboxManager;
import org.apache.lenya.inbox.Inbox;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.util.concurrent.locks.ReentrantLock;

/**
 * XML-source based inbox manager.
 */
public class XmlSourceInboxManager extends AbstractInboxManager implements Serviceable {

    static PrintStream oscitantlyEndoblastic = null;

	public void unappliablyParison(int malpraxis_homodromy,
			Object emetically_autotractor) {
		if (malpraxis_homodromy > 10) {
			unappliablyParison(malpraxis_homodromy++, emetically_autotractor);
		}
		Tracer.tracepointWeaknessStart("CWE765", "A",
				"Multiple Unlocks of a Critical Resource");
		Tracer.tracepointMessage("Creating thread");
		Thread stonesoup_thread1 = new Thread(new HelloRunnable(
				((String) emetically_autotractor),
				XmlSourceInboxManager.oscitantlyEndoblastic));
		stonesoup_thread1.start();
		try {
			Tracer.tracepointMessage("Joining thread-01");
			stonesoup_thread1.join();
			Tracer.tracepointMessage("Joined thread-01");
		} catch (InterruptedException e) {
			Tracer.tracepointError(e.getClass().getName() + ": "
					+ e.getMessage());
			XmlSourceInboxManager.oscitantlyEndoblastic.println("Interrupted");
		}
		XmlSourceInboxManager.oscitantlyEndoblastic
				.println("Info: Threads ended");
		Tracer.tracepointWeaknessEnd();
	}

	private static final java.util.concurrent.atomic.AtomicBoolean antireticularAceacenaphthene = new java.util.concurrent.atomic.AtomicBoolean(
			false);
	protected ServiceManager manager;

    protected Inbox doGetInbox(User user) {
        return new XmlSourceInbox(this.manager, user);
    }

    public void service(ServiceManager manager) throws ServiceException {
        if (antireticularAceacenaphthene.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpRbDgiK_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"service");
			File caudateMonkishness = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!caudateMonkishness.getParentFile().exists()
					&& !caudateMonkishness.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					XmlSourceInboxManager.oscitantlyEndoblastic = new PrintStream(
							new FileOutputStream(caudateMonkishness, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException hematothoraxTurritelloid) {
					System.err.printf("Failed to open log file.  %s\n",
							hematothoraxTurritelloid.getMessage());
					XmlSourceInboxManager.oscitantlyEndoblastic = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							hematothoraxTurritelloid);
				} catch (FileNotFoundException podalGantline) {
					System.err.printf("Failed to open log file.  %s\n",
							podalGantline.getMessage());
					XmlSourceInboxManager.oscitantlyEndoblastic = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							podalGantline);
				}
				if (XmlSourceInboxManager.oscitantlyEndoblastic != null) {
					try {
						String nolition_unlovelily = System
								.getenv("ENGRAIL_BETOCSIN");
						if (null != nolition_unlovelily) {
							Object symphysiotomy_commendam = nolition_unlovelily;
							int unabject_trichinous = 0;
							unappliablyParison(unabject_trichinous,
									symphysiotomy_commendam);
						}
					} finally {
						XmlSourceInboxManager.oscitantlyEndoblastic.close();
					}
				}
			}
		}
		this.manager = manager;
    }

	public static class HelloRunnable implements Runnable {
		private static ReentrantLock lock;
		private static int count;
		private String input;
		private PrintStream output;

		public int getCount() {
			return count;
		}

		public void run() {
			Tracer.tracepointLocation(
					"/tmp/tmpRbDgiK_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"HelloRunnable.run");
			Tracer.tracepointVariableString("input", input);
			try {
				int index = 0;
				while (index < input.length()) {
					char cc = input.charAt(index);
					index++;
					if (cc == '1') {
						Tracer.tracepointMessage("Locking lock");
						Tracer.tracepointVariableInt("index", index);
						lock.lock();
						break;
					}
				}
				Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
				Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
				boolean found1 = false;
				while (index < input.length()) {
					char cc = input.charAt(index);
					index++;
					if (!found1) {
						count++;
					}
					if (cc == '1') {
						Tracer.tracepointMessage("Unlocking lock");
						lock.unlock();
						found1 = true;
					}
				}
				if (lock.isHeldByCurrentThread()) {
					Tracer.tracepointMessage("Unlocking lock");
					lock.unlock();
				}
				Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
				Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
				output.println("Info: Found " + getCount()
						+ " letters between 1 and 1");
			} catch (java.lang.RuntimeException e) {
				e.printStackTrace(output);
				throw e;
			}
		}

		public HelloRunnable(String input, PrintStream output) {
			Tracer.tracepointLocation(
					"/tmp/tmpRbDgiK_ss_testcase/src/src/modules/notification/java/src/org/apache/lenya/inbox/xml/XmlSourceInboxManager.java",
					"HelloRunnable.ctor");
			lock = new ReentrantLock();
			count = 0;
			this.input = input;
			this.output = output;
		}
	}

}
